#include "TimerOne.h"

#define MAX_LONGuint16_t 65535 // Бесконечно длинный шаг, для эмуляции простоя.

#define STEP_L 10 //Пин левого шага 
#define STEP_R 12 //Пин правого шага 

#define portN_STEP_L B00000100 //Бит левого мотора в порту PORTB соответствует 10 пину, 
#define portN_STEP_R B00010000 //Бит правого мотора в порту PORTB соответствует 12 пину
#define portN_notSTEPs B11101011 //Байт-маска для опускание к нулю пинов шага обоих моторов, работает через 

#define STEPER_EN 8 //Пин врключения моторов// Функция инициализации уравления моторами.//////////////////////////////

#define DIR_R 11 //Пин направления левого шага 
#define DIR_L 9 //Пин направления правого шага

#define DIR_L_FRONT false //направления левого шага 
#define DIR_R_FRONT true //направления правого шага

#define DIR_L_BACK true //направления левого шага 
#define DIR_R_BACK false //направления правого шага

//=========================================
uint32_t speed_stepL;
uint32_t speed_stepR;
//=========================================
//=========================================
bool DIR_L_level = false;
bool DIR_R_level = false;
//=========================================
//=========================================
bool flag_off = false; //Флаг отключения двигателя
//=========================================
bool STEPER_EN_level = true;
volatile uint16_t schetchik_long_step_L = MAX_LONGuint16_t;
volatile uint16_t schetchik_long_step_R = MAX_LONGuint16_t;

volatile uint16_t tek_step_long_L_activ;
volatile uint16_t tek_step_long_R_activ;

byte xbyte;
//===============================
void setup_motor_system()
{
  DIR_L_level = false;
  DIR_R_level = false;
  STEPER_EN_level = true;

  pinMode(STEP_L, OUTPUT);
  pinMode(STEP_R, OUTPUT);
  pinMode(DIR_L, OUTPUT);
  pinMode(DIR_R, OUTPUT);
  pinMode(STEPER_EN, OUTPUT);

  digitalWrite(STEP_L, false);
  digitalWrite(STEP_R, false);
  digitalWrite(DIR_L, DIR_L_level);
  digitalWrite(DIR_R, DIR_R_level);
  digitalWrite(STEPER_EN, STEPER_EN_level);

}
//===============================
//===============================

// == Включение /отключние моторов
void motor_off()
{
  // Отключаем все колеса.
  if (!STEPER_EN_level)
  {
    STEPER_EN_level = true;
    digitalWrite(STEPER_EN, STEPER_EN_level);
  }
}
//===============================
void motor_on()
{
  // Включаем все колеса.
  if (STEPER_EN_level)
  {
    STEPER_EN_level = false;
    digitalWrite(STEPER_EN, STEPER_EN_level);
  }
}
//===============================
// Устанавливаем скорость согласно расчетам
void SetSpeed()
{
  motor_on();
  if (SpeedL == 0)
  {
    schetchik_long_step_L = tek_step_long_L_activ = MAX_LONGuint16_t;  //НЕ шагаем
  }
  else
  {
    // Для шага внутри прерывания
    float corStep = 50000.0 / SpeedL; 
    if (SpeedL > 0)
    {
      DIR_L_level = DIR_L_FRONT;
    }
    else
    {
      DIR_L_level = DIR_L_BACK;
      corStep = - corStep;
    }
    corStep = constrain(corStep, 16.0, 65000.0);
    digitalWrite(DIR_L, DIR_L_level);
    schetchik_long_step_L = tek_step_long_L_activ = uint16_t(round(corStep)); 
  }
//======================
 if (SpeedR == 0)
  {
    schetchik_long_step_R = tek_step_long_R_activ = MAX_LONGuint16_t;  //НЕ шагаем
  }
  else
  {
    // Для шага внутри прерывания
    float corStep = 50000.0 / SpeedR; 
    if (SpeedR > 0)
    {
      DIR_R_level = DIR_R_FRONT;
    }
    else
    {
      DIR_R_level = DIR_R_BACK;
      corStep = - corStep;
    }
    corStep = constrain(corStep, 16.0, 65000.0);
    //Serial.println(corStep);
    digitalWrite(DIR_R, DIR_R_level);
    schetchik_long_step_R = tek_step_long_R_activ = uint16_t(round(corStep)); 
    //Serial.println(xbyte2, BIN);
 }
}


//=========================================
//=========================================
void i_stepcoder() //Обработка по прерыванию
{
  xbyte = PORTB & portN_notSTEPs;
  //=========================================
  if (!schetchik_long_step_L)
  {
    schetchik_long_step_L = tek_step_long_L_activ;
    xbyte |= portN_STEP_L;
  }
  schetchik_long_step_L--;
  //=========================================
  if (!schetchik_long_step_R)
  {
    schetchik_long_step_R = tek_step_long_R_activ;
    xbyte |= portN_STEP_R;
  }
  schetchik_long_step_R--;
  PORTB = xbyte;
}
//=========================================
//=========================================

void stepcoder_setup()
{
  schetchik_long_step_L = MAX_LONGuint16_t;
  schetchik_long_step_R = MAX_LONGuint16_t;
  PORTB = PORTB &  portN_notSTEPs; //Отключаем сигнал шага
  tek_step_long_L_activ = MAX_LONGuint16_t;
  tek_step_long_R_activ = MAX_LONGuint16_t;

  Timer1.initialize(20);  //Перерывание срабатывает 1 раз в 20 microseconds,
  Timer1.attachInterrupt(i_stepcoder);
}
